Attribute VB_Name = "modBotScout"
'// modBotScout.bas
Option Explicit

Public Enum m_Return
    m_TEXT = 1
    m_Boolean = 2
End Enum

Private Const ERROR_SUCCESS  As Long = 0
Private Const BINDF_GETNEWESTVERSION As Long = &H10
Private Declare Function URLDownloadToFile Lib "urlmon" Alias "URLDownloadToFileA" (ByVal pCaller As Long, ByVal szURL As String, ByVal szFileName As String, ByVal dwReserved As Long, ByVal lpfnCB As Long) As Long

'// Botscout query URL
Const sBSURL = "http://botscout.com/test/?key="

'// Requires:
'//     lOpt (1,2 or 3) - tells the function whether you are querying a username, Email or IP
'//     sData - the username, email or IP you are querying
'//
'// Usage:
'//
'//     Dim sTemp As String: sTemp = QueryBotScout(1, "goodayMox")
'//     MsgBox sTemp, vbInformation + vbOKOnly, App.Title
'//
Public Function QueryBotScout(lOpt As Long, sData As String) As String
    Dim sResult As String, sTempFile As String, sQuery As String
    '// Ensure we have a temp file to pass to the DownloadFile function
    sTempFile = App.Path: If Right(sTempFile, 1) = "\" Then sTempFile = sTempFile & "bstemp.txt" Else sTempFile = sTempFile & "\bstemp.txt"
    Select Case lOpt
        Case 1 '// Query username
            sQuery = sBSURL & "&name=" & sData
        Case 2 '// Query Email
            sQuery = sBSURL & "&mail=" & sData
        Case 3 '// Query IP
            sQuery = sBSURL & "&ip=" & sData
    End Select
    sResult = DownloadFile(sQuery, sTempFile, m_TEXT)
    If sResult <> "FALSE" Then
        '// Note this does not check for the presence of errors, you'd need to check
        '// whether or not the response begins with "! " (the error description follows the space)
            If InStr(1, sResult, "Y|", vbTextCompare) > 0 Then sResult = "Match Found" Else sResult = "No Match"
    End If
    QueryBotScout = sResult
End Function

'// Requires:
'//     sSourceURL - The URL you want to download (via GET, URLDownloadToFile doesn't do POST requests)
'//     sLocalFile - The LOCAL (e.g. C:\temp.txt) file you want to store the contents of the webpage in
'//     m_ReturnAs - Determines whether you want the function to return a simple boolean (yes/no) or the content of the file (see: Public Enum m_Return)
'//
'// Usage:
'//
'//     Dim sTemp As String: sTemp = DownloadFile("http://google.com", "c:\temp.txt", m_TEXT)
'//     MsgBox sTemp, vbInformation + vbOKOnly, App.Title
'//
Public Function DownloadFile(sSourceURL As String, sLocalFile As String, m_ReturnAs As m_Return)
    Dim bRet As Boolean
    bRet = URLDownloadToFile(0&, sSourceURL, sLocalFile, BINDF_GETNEWESTVERSION, 0&) = ERROR_SUCCESS
    Select Case m_ReturnAs
        Case 1
            If bRet = False Then DownloadFile = "FALSE": Exit Function
            Dim ff As Long: ff = FreeFile()
            Open sLocalFile For Input As #ff
                DownloadFile = Input(LOF(ff), ff)
            Close #ff
        Case 2
            DownloadFile = bRet
    End Select
End Function
